@import "../init";

// TODO: All of these styles should live in drowl_media instead, move it
// we need to replace all media queries (maybe using container queries
// or our media-query body classes instead).

// Correct sizing for (SVG) vector images
.media-vector-image {
  img {
    width: 100%;
    height: auto;
  }
}

// Slideshows
.media-slideshow {
  background-color: var(--bs-body-bg);

  // Set a fix height to prevent the header slideshow from getting to high
  // This is also the default + fallback option
  &--height-limited,
  &:not([class*="media-slideshow--height"]) {
    --media-slideshow-limited-height: auto !important;

    @include media-breakpoint-up($default-header-image-breakpoint) {
      --media-slideshow-limited-height: var(--header-image-height) !important;
    }
  }
}

// Slideshow Slides
// =================

.media-slide {
  --overlay-box-font-size-on-small: var(--bs-body-font-size);
  --limited-media-slide-height: 600px;
  --overlay-box-max-width: 650px;
  position: relative; // fallback value - the slider lib will set this to absolute.
  overflow: hidden; // important for ken burns effect.
  height: 100%;
  // Reduce FOUC on page load
  background-color: var(--bs-body-bg);
  // Ensure image & overlay fill 100% of the slideshow wrapper
  display: flex;
  flex-direction: column;
  > * {
    flex: 1 1 auto;
  }

  // Limit the slides height if no media-slideshow wrappers is present,
  // as media slides are now work indipentently.
  // When wrapped in media-slideshow, the wrapper defines the height
  // by --media-slideshow-limited-height.
  height: var(--limited-media-slide-height);
  .media-slideshow & {
    height: 100%;
  }

  &__title > * {
    // Title inside the overlay box
    margin-top: 0;
    line-height: inherit;
  }

  &__text {
    > :last-child {
      margin-bottom: 0;
    }
  }

  &__content {
    // Further content of the overlay box
    list-style: none;
    padding: 0;
    margin: 0;
  }

  &__media {
    // Wraps the media itself (image / video)
    position: relative;
    overflow: hidden;

    img:not(.media__image),
    video,
    .media--player {
      max-width: none;
      width: 100%;
      height: 100%;
      object-fit: cover;
      object-position: center;
    }

    picture {
      display: block;
      height: 100%;
    }

    &--image {
      line-height: 0;
    }

    > .media-entity {
      height: 100%;
      display: flex;
      flex-direction: column;
      justify-content: center;
    }

    .media-video {
      line-height: 0;
      background: var(--bs-black);
    }
  }

  &__overlay-wrapper {
    position: absolute;
    top: 0;
    left: 0;
    z-index: 5;
    width: 100%;
    height: 100%;
    pointer-events: none;
    // Allow scrolling for overlong text
    overflow-y: auto;
  }

  &__overlay-box {
    // Position base for the .close-button
    position: relative;
    margin-bottom: 0;
    pointer-events: all;
    max-width: var(--overlay-box-max-width);
    &__close {
      float: right;
      transition-duration: 150ms;
      transform-origin: top right;

      &:not(:hover) {
        opacity: 0.5;
      }
      .ico {
        --icon-size: 1em;
      }
    }

    .btn {
      &:not(:first-child) {
        margin-top: var(--bs-spacer-3);
      }
    }

    p {
      line-height: inherit;
    }
  }

  // Overlay Box / Contents positioning
  &__position-wrapper {
    display: flex;
    height: 100%;
  }

  &__overlay-link {
    position: absolute;
    z-index: 6;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    font-size: 0px;
    color: transparent;
  }

  &--media-size-original {
    // Media option "Don't crop image/video"
    .media-slide__media {
      display: flex;
      flex-direction: column;
      justify-content: center;
      align-items: center;
      > picture > img:not(.media__image),
      > img:not(.media__image),
      video,
      .media--player {
        height: auto;
        width: 100%;
        object-fit: contain;
        max-height: 100%;
      }

      > picture > img:not(.media__image),
      > img:not(.media__image) {
        // Height 100% is needed for object-position to work
        height: 100%;
      }
    }

    .media-video,
    .media-remote-video {
      aspect-ratio: 16/9;
      height: auto;
      max-height: 100%;
      max-width: 100%;
    }

    .media-remote-video {
      height: 100%;
    }
  }

  &:not(.media-slide--media-size-original) {
    // if the video is cropped by its wrapper, prevent the player controls from showing up, even if the user right clicks the video.
    video {
      pointer-events: none;
    }
  }

  &--img-grid-container {
    // Media option "Limit image/video to page-width) => .media-slide__media gets the class .grid-container
    display: flex;
    flex-direction: column;
    justify-content: center;

    .media-slide__media {
      height: auto;
    }
  }

  &--video-on-background {
    .media-slide__media {
      z-index: 2;
    }
  }

  &__video-background-image {
    // If a video & image is selected for a .media-slide, the video will act
    // as primary media in front, the image will act as background image
    // (if the video is not set up to cover the whole slide itself).
    position: absolute;
    left: 0;
    top: 0;
    right: 0;
    bottom: 0;

    picture {
      height: 100%;
    }

    img {
      height: 100%;
      width: 100%;
      object-fit: cover;
      object-position: center center;
    }
  }

  a.photoswipe,
  span.photoswipe-gallery,
  .animation-wrapper {
    height: 100%;
  }
}
